Index: src/Patterns/Registry.hpp
===================================================================
--- src/Patterns/Registry.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Patterns/Registry.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,76 @@
+/*
+ * Registry.hpp
+ *
+ *  Based on Registry<Action> by Till Crueger.
+ *
+ *  The registry pattern is basically just a singleton map, wherein instantiations
+ *  of a class can be registered, unregistered and retrieved.
+ *
+ *  Created on: Jul 28, 2010
+ *      Author: heber
+ */
+
+#ifndef REGISTRY_HPP_
+#define REGISTRY_HPP_
+
+#include <map>
+
+/**
+ * This template produces a generic registry pattern.
+ *
+ * <h1> Registry Howto </h1>
+ *
+ * The registry is a class where instances of other classes are stored and be retrieved
+ * when desired. For this purpose a registry should always be a singleton (i.e. use both
+ * this registry and the singleton pattern to declare a registry class). It basically
+ * is simply a singleton container of a map, where the pointers to the class instances are
+ * stored by a string key and can be retrieved thereby.
+ *
+ * The available functions are, if your class to be stored in registry is foo :
+ *
+ * - <code>foo* Registry<foo>::getByName()</code> : returns the instance of a specific
+ *    class foo instance as a pointer associated with the given name
+ * - <code>bool Registry<foo>::isPresentByName()</code> : returns whether an instance
+ *    of class foo is present under the given name.
+ * - <code>map<string,foo*>::iterator Registry<foo>::getBeginIter()</code> : returns an
+ *    iterator to the beginning of the storage map (STL).
+ * - <code>map<string,foo*>::const_iterator Registry<foo>::getBeginIter()</code> : returns a
+ *    constant iterator to the beginning of the storage map (STL).
+ * - <code>map<string,foo*>::const_iterator Registry<foo>::getEndIter()</code> : returns an
+ *    iterator to the one step past the last element of the storage map (STL).
+ * - <code>map<string,foo*>::const_iterator Registry<foo>::getEndIter()</code> : returns a
+ *    constant iterator to the one step past the last element of the storage map (STL).
+ *
+ * In order to use this pattern, additionally to the requirements of the Singleton pattern,
+ * do this:
+ *   -# in the declaration derive your class from Registry<foo>, where foo is the class to be
+ *      stored
+ *   -# in the definition add CONSTRUCT_REGISTRY(foo) to the code such that the templated
+ *      functions get instantiated there (otherwise you'll get undefined reference errors).
+ *
+ */
+
+template <class T>
+class Registry
+{
+public:
+  Registry();
+  ~Registry();
+
+  T* getByName(const std::string name);
+  bool isPresentByName(const std::string name);
+  void registerInstance(T*);
+  void unregisterInstance(T*);
+
+  typename std::map<const std::string,T*>::iterator getBeginIter();
+  typename std::map<const std::string,T*>::const_iterator getBeginIter() const;
+  typename std::map<const std::string,T*>::iterator getEndIter();
+  typename std::map<const std::string,T*>::const_iterator getEndIter() const;
+
+private:
+  typename std::map<const std::string,T*> InstanceMap;
+};
+
+template <class T> std::ostream& operator<<(std::ostream& ost, const Registry<T>& m);
+
+#endif /* REGISTRY_HPP_ */
Index: src/Patterns/Registry_impl.hpp
===================================================================
--- src/Patterns/Registry_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Patterns/Registry_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,141 @@
+/*
+ * Registry_impl.hpp
+ *
+ *  Created on: Jul 28, 2010
+ *      Author: heber
+ */
+
+#ifndef REGISTRY_IMPL_HPP_
+#define REGISTRY_IMPL_HPP_
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Patterns/Registry.hpp"
+#include "Patterns/Singleton_impl.hpp"
+
+#include "Helpers/Assert.hpp"
+#include <iosfwd>
+
+/** Constructor for class Registry.
+ */
+template <class T> Registry<T>::Registry()
+{}
+
+/** Destructor for class Registry.
+ */
+template <class T> Registry<T>::~Registry()
+{
+  typename std::map<const std::string,T*>::iterator iter;
+  for(iter=InstanceMap.begin();iter!=InstanceMap.end();++iter) {
+    delete iter->second;
+  }
+  InstanceMap.clear();
+}
+
+/** Returns pointer to an instance named by \a name.
+ * \param name name of instance
+ * \return pointer to instance
+ */
+template <class T> T* Registry<T>::getByName(const std::string name){
+  typename std::map<const std::string,T*>::iterator iter;
+  iter = InstanceMap.find(name);
+  ASSERT(iter!=InstanceMap.end(),"Query for an instance not stored in registry");
+  return iter->second;
+}
+
+/** States whether instance is present or not.
+ * \note This is needed as Registry<T>::getByName() ASSERT()s that instance is in std::map.
+ * \param name name of instance
+ * \return true - v present, false - instance absent
+ */
+template <class T>bool Registry<T>::isPresentByName(const std::string name){
+  typename std::map<const std::string,T*>::iterator iter;
+  iter = InstanceMap.find(name);
+  return iter!=InstanceMap.end();
+}
+
+/** Registers an instance with the Registry.
+ * \param *instance pointer to T.
+ */
+template <class T>void Registry<T>::registerInstance(T* instance){
+  std::pair<typename std::map<const std::string,T*>::iterator,bool> ret;
+  //cout << "Trying to register instance with name " << instance->getName() << "." << endl;
+  ret = InstanceMap.insert(typename std::pair<const std::string,T*>(instance->getName(),instance));
+  ASSERT(ret.second,"Two instances with the same name added to registry");
+}
+
+/** Unregisters an instance.
+ * \param *instance pointer to instance.
+ */
+template <class T>void Registry<T>::unregisterInstance(T* instance){
+  //cout << "Unregistering instance with name " << instance->getName() << "." << endl;
+  InstanceMap.erase(instance->getName());
+}
+
+/** Returns an iterator pointing to the start of the std::map of instance's.
+ * \return begin iterator
+ */
+template <class T>
+typename std::map<const std::string,T*>::iterator Registry<T>::getBeginIter()
+{
+  return InstanceMap.begin();
+}
+
+/** Returns an iterator pointing to the end of the std::map of instance's.
+ * \return end iterator
+ */
+template <class T>
+typename std::map<const std::string,T*>::iterator Registry<T>::getEndIter()
+{
+  return InstanceMap.end();
+}
+
+/** Returns a const iterator pointing to the start of the std::map of instance's.
+ * \return constant begin iterator
+ */
+template <class T>
+typename std::map<const std::string,T*>::const_iterator Registry<T>::getBeginIter() const
+{
+  return InstanceMap.begin();
+}
+
+/** Returns a const iterator pointing to the end of the std::map of instance's.
+ * \return constant end iterator
+ */
+template <class T>
+typename std::map<const std::string,T*>::const_iterator Registry<T>::getEndIter() const
+{
+  return InstanceMap.end();
+}
+
+/** Prints the contents of the Registry \a &m to \a &ost.
+ * \param &ost output stream
+ * \param &m reference to Registry
+ * \return reference to the above out stream for concatenation
+ */
+template <class T>
+std::ostream& operator<<(std::ostream& ost, const Registry<T>& m)
+{
+  ost << "Registry contains:" << std::endl;
+  for (typename std::map<const std::string,T*>::const_iterator iter = m.getBeginIter(); iter != m.getEndIter(); ++iter) {
+    ost << "\t" << iter->first << " with pointer " << iter->second << std::endl;
+  }
+  return ost;
+};
+
+/**
+ * This define allows simple instantiation of the necessary registryfunctions
+ * at a chosen place.
+ */
+#define CONSTRUCT_REGISTRY(name) \
+    template name* Registry<name>::getByName(const std::string name); \
+    template bool Registry<name>::isPresentByName(const std::string name); \
+    template void Registry<name>::registerInstance(name*); \
+    template void Registry<name>::unregisterInstance(name*); \
+    template std::map<const std::string,name*>::iterator Registry<name>::getBeginIter(); \
+    template std::map<const std::string,name*>::const_iterator Registry<name>::getBeginIter() const; \
+    template std::map<const std::string,name*>::iterator Registry<name>::getEndIter(); \
+    template std::map<const std::string,name*>::const_iterator Registry<name>::getEndIter() const;
+
+
+#endif /* REGISTRY_IMPL_HPP_ */
Index: src/PointCloud.cpp
===================================================================
--- src/PointCloud.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/PointCloud.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,32 @@
+/*
+ * PointCloud.cpp
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "PointCloud.hpp"
+
+/** Constructor of class PointCloud.
+ */
+PointCloud::PointCloud()
+{
+  //Info FunctionInfo(__func__);
+}
+;
+
+/** Destructor for class PointCloud.
+ */
+PointCloud::~PointCloud()
+{
+  //Info FunctionInfo(__func__);
+}
+;
+
Index: src/PointCloud.hpp
===================================================================
--- src/PointCloud.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/PointCloud.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,35 @@
+/*
+ * PointCloud.hpp
+ *
+ *  Created on: Jul 29, 2010
+ *      Author: heber
+ */
+
+#ifndef POINTCLOUD_HPP_
+#define POINTCLOUD_HPP_
+
+#include <cstdio>
+
+class TesselPoint;
+class Vector;
+
+/** Super-class for all point clouds structures, also molecules. They have to inherit this structure and implement the virtual function to access the Vectors.
+ * This basically encapsulates a list structure.
+ */
+class PointCloud {
+public:
+  PointCloud();
+  virtual ~PointCloud();
+
+  virtual const char * const GetName() const { return "unknown"; };
+  virtual Vector *GetCenter() const { return NULL; };
+  virtual TesselPoint *GetPoint() const { return NULL; };
+  virtual int GetMaxId() const { return 0; };
+  virtual void GoToNext() const {};
+  virtual void GoToFirst() const {};
+  virtual bool IsEmpty() const { return true; };
+  virtual bool IsEnd() const { return true; };
+};
+
+
+#endif /* POINTCLOUD_HPP_ */
Index: src/Shapes/BaseShapes.cpp
===================================================================
--- src/Shapes/BaseShapes.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/BaseShapes.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,77 @@
+/*
+ * BaseShapes_impl.cpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Shapes/BaseShapes.hpp"
+#include "Shapes/BaseShapes_impl.hpp"
+
+#include <cmath>
+
+#include "Helpers/Assert.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+bool Sphere_impl::isInside(const Vector &point){
+  return point.NormSquared()<=1;
+}
+
+
+/**
+ * algorithm taken from http://www.cgafaq.info/wiki/Evenly_distributed_points_on_sphere
+ * \param N number of points on surface
+ */
+std::vector<Vector> Sphere_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface;
+
+  const double dlength = M_PI*(3.-sqrt(5.));
+  double length = 0;
+  const double dz = 2.0/N;
+  double z = 1. - dz/2.;
+  Vector point;
+  for (int ka = 0; ka<N; ka++){
+    const double r = sqrt(1.-z*z);
+    point.Zero();
+    point[0] = cos(length)*r;
+    point[1] = sin(length)*r;
+    point[2] = z;
+    PointsOnSurface.push_back(point);
+    z = z - dz;
+    length = length + dlength;
+  }
+
+  ASSERT(PointsOnSurface.size() == N, "Sphere_impl::getHomogeneousPointsOnSurface() did not create enough points.");
+  return PointsOnSurface;
+}
+
+
+Shape Sphere(){
+  Shape::impl_ptr impl = Shape::impl_ptr(new Sphere_impl());
+  return Shape(impl);
+}
+
+bool Cuboid_impl::isInside(const Vector &point){
+  return (point[0]>=0 && point[0]<=1) && (point[1]>=0 && point[1]<=1) && (point[2]>=0 && point[2]<=1);
+}
+
+/**
+ * \param N number of points on surface
+ */
+std::vector<Vector> Cuboid_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface;
+  ASSERT(false, "Cuboid_impl::getHomogeneousPointsOnSurface() not implemented yet");
+  return PointsOnSurface;
+}
+
+Shape Cuboid(){
+  Shape::impl_ptr impl = Shape::impl_ptr(new Cuboid_impl());
+  return Shape(impl);
+}
Index: src/Shapes/BaseShapes.hpp
===================================================================
--- src/Shapes/BaseShapes.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/BaseShapes.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,16 @@
+/*
+ * BaseShapes.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef BASESHAPES_HPP_
+#define BASESHAPES_HPP_
+
+#include "Shapes/Shape.hpp"
+
+Shape Sphere();
+Shape Cuboid();
+
+#endif /* BASESHAPES_HPP_ */
Index: src/Shapes/BaseShapes_impl.hpp
===================================================================
--- src/Shapes/BaseShapes_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/BaseShapes_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,23 @@
+/*
+ * BaseShapes_impl.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef BASESHAPES_IMPL_HPP_
+#define BASESHAPES_IMPL_HPP_
+
+#include "Shapes/Shape_impl.hpp"
+
+class Sphere_impl : public Shape_impl {
+  virtual bool isInside(const Vector &point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+};
+
+class Cuboid_impl : public Shape_impl {
+  virtual bool isInside(const Vector &point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+};
+
+#endif /* BASESHAPES_IMPL_HPP_ */
Index: src/Shapes/Shape.cpp
===================================================================
--- src/Shapes/Shape.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/Shape.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,159 @@
+/*
+ * Shape.cpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Shape.hpp"
+#include "Shape_impl.hpp"
+
+
+#include "Helpers/Assert.hpp"
+#include "LinearAlgebra/Vector.hpp"
+
+Shape::Shape(const Shape& src) :
+  impl(src.getImpl())
+{}
+
+Shape::~Shape(){}
+
+bool Shape::isInside(const Vector &point) const{
+  return impl->isInside(point);
+}
+
+std::vector<Vector> Shape::getHomogeneousPointsOnSurface(const int N) const {
+  return impl->getHomogeneousPointsOnSurface(N);
+}
+
+Shape::Shape(Shape::impl_ptr _impl) :
+    impl(_impl)
+{}
+
+Shape &Shape::operator=(const Shape& rhs){
+  if(&rhs!=this){
+    impl=rhs.getImpl();
+  }
+  return *this;
+}
+
+Shape::impl_ptr Shape::getImpl() const{
+  return impl;
+}
+
+// allows arbitrary friendship, but only if implementation is known
+Shape::impl_ptr getShapeImpl(const Shape &shape){
+  return shape.getImpl();
+}
+
+/***************************** Some simple Shapes ***************************/
+
+Shape Everywhere(){
+  static Shape::impl_ptr impl = Shape::impl_ptr(new Everywhere_impl());
+  return Shape(impl);
+}
+
+Shape Nowhere(){
+  static Shape::impl_ptr impl = Shape::impl_ptr(new Nowhere_impl());
+  return Shape(impl);
+}
+
+/****************************** Operators ***********************************/
+
+// AND
+
+AndShape_impl::AndShape_impl(const Shape::impl_ptr &_lhs, const Shape::impl_ptr &_rhs) :
+  lhs(_lhs),rhs(_rhs)
+{}
+
+AndShape_impl::~AndShape_impl(){}
+
+bool AndShape_impl::isInside(const Vector &point){
+  return lhs->isInside(point) && rhs->isInside(point);
+}
+
+std::vector<Vector> AndShape_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface_lhs = lhs->getHomogeneousPointsOnSurface(N);
+  std::vector<Vector> PointsOnSurface_rhs = rhs->getHomogeneousPointsOnSurface(N);
+  std::vector<Vector> PointsOnSurface;
+
+  for (std::vector<Vector>::const_iterator iter = PointsOnSurface_lhs.begin(); iter != PointsOnSurface_lhs.end(); ++iter) {
+    if (rhs->isInside(*iter))
+      PointsOnSurface.push_back(*iter);
+  }
+  for (std::vector<Vector>::const_iterator iter = PointsOnSurface_rhs.begin(); iter != PointsOnSurface_rhs.end(); ++iter) {
+    if (lhs->isInside(*iter))
+      PointsOnSurface.push_back(*iter);
+  }
+
+  return PointsOnSurface;
+}
+
+
+Shape operator&&(const Shape &lhs,const Shape &rhs){
+  Shape::impl_ptr newImpl = Shape::impl_ptr(new AndShape_impl(getShapeImpl(lhs),getShapeImpl(rhs)));
+  return Shape(newImpl);
+}
+
+// OR
+
+OrShape_impl::OrShape_impl(const Shape::impl_ptr &_lhs, const Shape::impl_ptr &_rhs) :
+  lhs(_lhs),rhs(_rhs)
+{}
+
+OrShape_impl::~OrShape_impl(){}
+
+bool OrShape_impl::isInside(const Vector &point){
+  return rhs->isInside(point) || lhs->isInside(point);
+}
+
+std::vector<Vector> OrShape_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface_lhs = lhs->getHomogeneousPointsOnSurface(N);
+  std::vector<Vector> PointsOnSurface_rhs = rhs->getHomogeneousPointsOnSurface(N);
+  std::vector<Vector> PointsOnSurface;
+
+  for (std::vector<Vector>::const_iterator iter = PointsOnSurface_lhs.begin(); iter != PointsOnSurface_lhs.end(); ++iter) {
+    if (!rhs->isInside(*iter))
+      PointsOnSurface.push_back(*iter);
+  }
+  for (std::vector<Vector>::const_iterator iter = PointsOnSurface_rhs.begin(); iter != PointsOnSurface_rhs.end(); ++iter) {
+    if (!lhs->isInside(*iter))
+      PointsOnSurface.push_back(*iter);
+  }
+
+  return PointsOnSurface;
+}
+
+Shape operator||(const Shape &lhs,const Shape &rhs){
+  Shape::impl_ptr newImpl = Shape::impl_ptr(new OrShape_impl(getShapeImpl(lhs),getShapeImpl(rhs)));
+  return Shape(newImpl);
+}
+
+// NOT
+
+NotShape_impl::NotShape_impl(const Shape::impl_ptr &_arg) :
+  arg(_arg)
+{}
+
+NotShape_impl::~NotShape_impl(){}
+
+bool NotShape_impl::isInside(const Vector &point){
+  return !arg->isInside(point);
+}
+
+std::vector<Vector> NotShape_impl::getHomogeneousPointsOnSurface(const int N) const {
+  // surfaces are the same, only normal direction is different
+  return arg->getHomogeneousPointsOnSurface(N);
+}
+
+Shape operator!(const Shape &arg){
+  Shape::impl_ptr newImpl = Shape::impl_ptr(new NotShape_impl(getShapeImpl(arg)));
+  return Shape(newImpl);
+}
Index: src/Shapes/Shape.hpp
===================================================================
--- src/Shapes/Shape.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/Shape.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,47 @@
+/*
+ * Shape.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPE_HPP_
+#define SHAPE_HPP_
+
+#include <boost/shared_ptr.hpp>
+
+#include <vector>
+
+class Vector;
+class Shape_impl;
+
+class Shape
+{
+public:
+  typedef boost::shared_ptr<Shape_impl> impl_ptr;
+  friend impl_ptr getShapeImpl(const Shape&);
+
+  Shape(impl_ptr);
+  Shape(const Shape&);
+  virtual ~Shape();
+
+  bool isInside(const Vector &point) const;
+  std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+
+  Shape &operator=(const Shape& rhs);
+
+protected:
+  impl_ptr getImpl() const;
+
+private:
+  impl_ptr impl;
+};
+
+Shape Everywhere();
+Shape Nowhere();
+
+Shape operator&&(const Shape&,const Shape&);
+Shape operator||(const Shape&,const Shape&);
+Shape operator!(const Shape&);
+
+#endif /* SHAPE_HPP_ */
Index: src/Shapes/ShapeOps.cpp
===================================================================
--- src/Shapes/ShapeOps.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/ShapeOps.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,132 @@
+/*
+ * ShapeOps.cpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "Shapes/ShapeOps.hpp"
+#include "Shapes/ShapeOps_impl.hpp"
+
+#include "Helpers/Assert.hpp"
+
+/********************* Resize ********************/
+
+Resize_impl::Resize_impl(const Shape::impl_ptr &_arg,double _size) :
+  arg(_arg), size(_size)
+{
+  ASSERT(size>0,"Cannot resize a Shape to size zero or below");
+}
+
+Resize_impl::~Resize_impl(){}
+
+bool Resize_impl::isInside(const Vector& point){
+  return arg->isInside((1/size) * point);
+}
+
+std::vector<Vector> Resize_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface = arg->getHomogeneousPointsOnSurface(N);
+  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
+    *iter *= size;
+  }
+  return PointsOnSurface;
+}
+
+
+Shape resize(const Shape &arg,double size){
+  Shape::impl_ptr impl = Shape::impl_ptr(new Resize_impl(getShapeImpl(arg),size));
+  return Shape(impl);
+}
+
+/*************************** translate *******************/
+
+Translate_impl::Translate_impl(const Shape::impl_ptr &_arg, const Vector &_offset) :
+  arg(_arg),offset(_offset)
+{}
+
+Translate_impl::~Translate_impl(){}
+
+bool Translate_impl::isInside(const Vector& point){
+  return arg->isInside(point-offset);
+}
+
+std::vector<Vector> Translate_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface = arg->getHomogeneousPointsOnSurface(N);
+  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
+    *iter += offset;
+  }
+  return PointsOnSurface;
+}
+
+Shape translate(const Shape &arg, const Vector &offset){
+  Shape::impl_ptr impl = Shape::impl_ptr(new Translate_impl(getShapeImpl(arg),offset));
+  return Shape(impl);
+}
+
+/*********************** stretch ******************/
+
+Stretch_impl::Stretch_impl(const Shape::impl_ptr &_arg, const Vector &_factors) :
+  arg(_arg),factors(_factors)
+{
+  ASSERT(factors[0]>0,"cannot stretch a shape by a negative amount");
+  ASSERT(factors[1]>0,"cannot stretch a shape by a negative amount");
+  ASSERT(factors[2]>0,"cannot stretch a shape by a negative amount");
+  for(int i = NDIM;i--;){
+    reciFactors[i] = 1/factors[i];
+  }
+}
+
+Stretch_impl::~Stretch_impl(){}
+
+bool Stretch_impl::isInside(const Vector& point){
+  Vector helper=point;
+  helper.ScaleAll(reciFactors);
+  return arg->isInside(helper);
+}
+
+std::vector<Vector> Stretch_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface = arg->getHomogeneousPointsOnSurface(N);
+  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
+    (*iter).ScaleAll(reciFactors);
+  }
+  return PointsOnSurface;
+}
+
+Shape stretch(const Shape &arg, const Vector &factors){
+  Shape::impl_ptr impl = Shape::impl_ptr(new Stretch_impl(getShapeImpl(arg),factors));
+  return Shape(impl);
+}
+
+/************************* transform *****************/
+
+Transform_impl::Transform_impl(const Shape::impl_ptr &_arg, const Matrix &_transformation) :
+  arg(_arg),transformation(_transformation)
+{
+  transformationInv = transformation.invert();
+}
+
+Transform_impl::~Transform_impl(){}
+
+bool Transform_impl::isInside(const Vector& point){
+  return arg->isInside(transformationInv * point);
+}
+
+std::vector<Vector> Transform_impl::getHomogeneousPointsOnSurface(const int N) const {
+  std::vector<Vector> PointsOnSurface = arg->getHomogeneousPointsOnSurface(N);
+  for(std::vector<Vector>::iterator iter = PointsOnSurface.begin(); iter != PointsOnSurface.end(); ++iter) {
+    *iter = transformation * (*iter);
+  }
+  return PointsOnSurface;
+}
+
+Shape transform(const Shape &arg, const Matrix &transformation){
+  Shape::impl_ptr impl = Shape::impl_ptr(new Transform_impl(getShapeImpl(arg),transformation));
+  return Shape(impl);
+}
Index: src/Shapes/ShapeOps.hpp
===================================================================
--- src/Shapes/ShapeOps.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/ShapeOps.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,20 @@
+/*
+ * ShapeOps.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPEOPS_HPP_
+#define SHAPEOPS_HPP_
+
+#include "Shapes/Shape.hpp"
+
+class Matrix;
+
+Shape resize(const Shape&,double);
+Shape translate(const Shape&, const Vector&);
+Shape stretch(const Shape&, const Vector&);
+Shape transform(const Shape&,const Matrix&);
+
+#endif /* SHAPEOPS_HPP_ */
Index: src/Shapes/ShapeOps_impl.hpp
===================================================================
--- src/Shapes/ShapeOps_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/ShapeOps_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,65 @@
+/*
+ * ShapeOps_impl.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPEOPS_IMPL_HPP_
+#define SHAPEOPS_IMPL_HPP_
+
+#include "Shapes/Shape_impl.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+
+class Resize_impl :  public Shape_impl
+{
+public:
+  Resize_impl(const Shape::impl_ptr&,double);
+  virtual ~Resize_impl();
+  virtual bool isInside(const Vector& point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr arg;
+  double size;
+};
+
+class Translate_impl :  public Shape_impl
+{
+public:
+  Translate_impl(const Shape::impl_ptr&, const Vector&);
+  virtual ~Translate_impl();
+  virtual bool isInside(const Vector& point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr arg;
+  Vector offset;
+};
+
+class Stretch_impl : public Shape_impl
+{
+public:
+  Stretch_impl(const Shape::impl_ptr&, const Vector&);
+  virtual ~Stretch_impl();
+  virtual bool isInside(const Vector& point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr arg;
+  Vector factors;
+  Vector reciFactors;
+};
+
+class Transform_impl : public Shape_impl
+{
+public:
+  Transform_impl(const Shape::impl_ptr&, const Matrix&);
+  virtual ~Transform_impl();
+  virtual bool isInside(const Vector& point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr arg;
+  Matrix transformation;
+  Matrix transformationInv;
+};
+
+#endif /* SHAPEOPS_IMPL_HPP_ */
Index: src/Shapes/Shape_impl.hpp
===================================================================
--- src/Shapes/Shape_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Shapes/Shape_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,80 @@
+/*
+ * Shape_impl.hpp
+ *
+ *  Created on: Jun 18, 2010
+ *      Author: crueger
+ */
+
+#ifndef SHAPE_IMPL_HPP_
+#define SHAPE_IMPL_HPP_
+
+#include <vector>
+
+#include "Shapes/Shape.hpp"
+
+class Vector;
+
+class Shape_impl {
+public:
+  Shape_impl(){};
+  virtual ~Shape_impl(){};
+  virtual bool isInside(const Vector &point)=0;
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const=0;
+};
+
+class Everywhere_impl : public Shape_impl {
+public:
+  virtual bool isInside(const Vector &point){
+    return true;
+  }
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const {
+    std::vector<Vector> PointsOnSurface;
+    return PointsOnSurface;
+  }
+};
+
+class Nowhere_impl : public Shape_impl {
+  virtual bool isInside(const Vector &point){
+    return false;
+  }
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const {
+    std::vector<Vector> PointsOnSurface;
+    return PointsOnSurface;
+  }
+};
+
+class AndShape_impl : public Shape_impl {
+public:
+  AndShape_impl(const Shape::impl_ptr&, const Shape::impl_ptr&);
+  virtual ~AndShape_impl();
+  virtual bool isInside(const Vector &point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr lhs;
+  Shape::impl_ptr rhs;
+};
+
+class OrShape_impl : public Shape_impl {
+public:
+  OrShape_impl(const Shape::impl_ptr&, const Shape::impl_ptr&);
+  virtual ~OrShape_impl();
+  virtual bool isInside(const Vector &point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr lhs;
+  Shape::impl_ptr rhs;
+};
+
+class NotShape_impl : public Shape_impl {
+public:
+  NotShape_impl(const Shape::impl_ptr&);
+  virtual ~NotShape_impl();
+  virtual bool isInside(const Vector &point);
+  virtual std::vector<Vector> getHomogeneousPointsOnSurface(const int N) const;
+private:
+  Shape::impl_ptr arg;
+};
+
+Shape::impl_ptr getShapeImpl(const Shape&);
+
+#endif /* SHAPE_IMPL_HPP_ */
Index: src/TesselPoint.cpp
===================================================================
--- src/TesselPoint.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/TesselPoint.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,43 @@
+/*
+ * TesselPoint.cpp
+ *
+ *  Created on: Jul 30, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
+#include "TesselPoint.hpp"
+
+#include <iostream>
+
+
+/** Constructor of class TesselPoint.
+ */
+TesselPoint::TesselPoint()
+{};
+
+/** Destructor for class TesselPoint.
+ */
+TesselPoint::~TesselPoint()
+{};
+
+std::ostream & TesselPoint::operator << (std::ostream &ost) const
+{
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
+
+std::ostream & operator << (std::ostream &ost, const TesselPoint &a)
+{
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
+
Index: src/TesselPoint.hpp
===================================================================
--- src/TesselPoint.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/TesselPoint.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,27 @@
+/*
+ * TesselPoint.hpp
+ *
+ *  Created on: Jul 30, 2010
+ *      Author: heber
+ */
+
+#ifndef TESSELPOINT_HPP_
+#define TESSELPOINT_HPP_
+
+#include "atom_atominfo.hpp"
+#include "atom_particleinfo.hpp"
+
+class TesselPoint;
+
+class TesselPoint : public virtual ParticleInfo, public virtual AtomInfo
+{
+public:
+  TesselPoint();
+  ~TesselPoint();
+
+  std::ostream & operator << (std::ostream &ost) const;
+};
+
+std::ostream & operator << (std::ostream &ost, const TesselPoint &t);
+
+#endif /* TESSELPOINT_HPP_ */
Index: src/ThermoStatContainer.cpp
===================================================================
--- src/ThermoStatContainer.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/ThermoStatContainer.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,17 +6,31 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include <cstring>
 
 #include "ConfigFileBuffer.hpp"
 #include "config.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "ThermoStatContainer.hpp"
-#include "verbose.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor for class ThermoStatContainer.
  *
  */
-ThermoStatContainer::ThermoStatContainer() : Thermostat(4), ThermostatImplemented(NULL),
-ThermostatNames(NULL), TempFrequency(2.5), alpha(0.), HooverMass(0.), TargetTemp(0.00095004455), ScaleTempStep(25)
+ThermoStatContainer::ThermoStatContainer() :
+  Thermostat(4),
+  ThermostatImplemented(NULL),
+  ThermostatNames(NULL),
+  TempFrequency(2.5),
+  alpha(0.),
+  HooverMass(0.),
+  TargetTemp(0.00095004455),
+  ScaleTempStep(25)
 {
   ThermostatImplemented = new int[MaxThermostats];
